(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs/Observable'), require('rxjs/add/operator/distinctUntilChanged'), require('rxjs/Subscription'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'rxjs/Observable', 'rxjs/add/operator/distinctUntilChanged', 'rxjs/Subscription', '@angular/common'], factory) :
	(factory((global['sws-loading-udfl'] = {}),global.ng.core,global.Rx,global.Rx.Observable.prototype,global.Rx,global.ng.common));
}(this, (function (exports,core,Observable,distinctUntilChanged,Subscription,common) { 'use strict';

var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
var LoadingState = /** @class */ (function () {
    function LoadingState() {
    }
    /**
     * @param {?} data
     * @return {?}
     */
    LoadingState.prototype.finishLoad = function (data) {
        this.error = false;
        this.loading = false;
        this.state = 'finish';
        if (data == null) {
            this.notFound = true;
        }
        else {
            this.notFound = false;
        }
    };
    /**
     * @return {?}
     */
    LoadingState.prototype.startLoad = function () {
        this.error = false;
        this.notFound = false;
        this.loading = true;
        this.state = 'start';
    };
    /**
     * @param {?} error
     * @return {?}
     */
    LoadingState.prototype.errorLoad = function (error) {
        this.error = true;
        this.loading = false;
        console.error(error);
    };
    return LoadingState;
}());
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwsLoadingComponent = /** @class */ (function (_super) {
    __extends(SwsLoadingComponent, _super);
    function SwsLoadingComponent() {
        var _this = _super.call(this) || this;
        _this.textNotFound = 'Данные отсутствуют.';
        _this.textError = 'Ошибка загрузки данных. Повторите попытку чуть позже.';
        _this.download = false;
        _this.dataOut = new core.EventEmitter();
        _this.downloadChange = false;
        _this.subscription = new Subscription.Subscription();
        return _this;
    }
    /**
     * @return {?}
     */
    SwsLoadingComponent.prototype.ngOnInit = function () {
        this.oldObs = this.dataObservable;
        if (this.download && this.dataObservable) {
            this.loadData();
        }
    };
    /**
     * @param {?} changes
     * @return {?}
     */
    SwsLoadingComponent.prototype.ngOnChanges = function (changes) {
        // если используется состояние таба\аккордиона как критерий для загрузки
        if (typeof this.download === 'boolean') {
            // при первом открытии аккордиона\табы
            if (this.download && !this.downloadChange) {
                this.downloadChange = true;
                this.loadData();
            }
            // если был изменен observable и аккордион\таб открыт
            if (this.dataObservable !== this.oldObs && this.download) {
                this.loadData();
                this.oldObs = this.dataObservable;
            }
        }
        else {
            // если используется Observable как критерий для загрузки
            if (!changes['dataObservable'].firstChange) {
                this.loadData();
            }
        }
    };
    /**
     * @return {?}
     */
    SwsLoadingComponent.prototype.loadData = function () {
        var _this = this;
        _super.prototype.startLoad.call(this);
        this.subscription.add(this.dataObservable.distinctUntilChanged().subscribe(function (response) { return _this.data = response; }, function (error) { return _this.errorLoad(_this.data, error); }, function () { return _this.completeLoad(_this.data); }));
    };
    /**
     * @param {?} data
     * @return {?}
     */
    SwsLoadingComponent.prototype.completeLoad = function (data) {
        console.log('completeLoad data', data);
        this.dataOut.emit(data);
        data = this.checkTypeData(data);
        _super.prototype.finishLoad.call(this, data);
    };
    /**
     * @param {?} data
     * @param {?=} error
     * @return {?}
     */
    SwsLoadingComponent.prototype.errorLoad = function (data, error) {
        console.log('errorLoad data', data);
        console.log('errorLoad error', error);
        // this.dataOut.emit(data);
        _super.prototype.errorLoad.call(this, error);
    };
    /**
     * @param {?} data
     * @return {?}
     */
    SwsLoadingComponent.prototype.checkTypeData = function (data) {
        if (this.isTable) {
            if (!data[0] || !data[1]) {
                return null;
            }
            else {
                return data;
            }
        }
        else {
            return data;
        }
    };
    /**
     * @return {?}
     */
    SwsLoadingComponent.prototype.ngOnDestroy = function () {
        this.subscription.unsubscribe();
    };
    return SwsLoadingComponent;
}(LoadingState));
SwsLoadingComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'sws-loading-udfl, [sws-loading-udfl]',
                template: "<div *ngIf=\"notFound\" class=\"algcenter\">\n    {{textNotFound}}\n</div>\n<!--<div *ngIf=\"error\" class=\"algcenter\">\n    {{textError}}\n    <span (click)=\"loadData()\" style=\"cursor: pointer; color:#FF8F3A\"> \u041F\u043E\u043F\u0440\u043E\u0431\u0443\u0439\u0442\u0435 \u0435\u0449\u0435 \u0440\u0430\u0437</span>\n</div>-->\n<div *ngIf=\"error\" class=\"algcenter\">{{textNotFound}}</div>\n<div style=\"position: relative; min-height: 200px; overflow: hidden;\">\n    <div class=\"round\" *ngIf=\"loading\">\n    </div>\n    <div *ngIf=\"!notFound\">\n        <ng-content></ng-content>\n    </div>\n</div>\n",
                styles: [".pane {\n  padding: 1em; }\n\n.hidden {\n  visibility: hidden; }\n\n.loading {\n  opacity: 0.5; }\n\n.algcenter {\n  text-align: center; }\n\n.center {\n  margin-left: auto;\n  margin-right: auto; }\n\n.round {\n  height: 100%;\n  width: 100%;\n  background-color: rgba(255, 255, 255, 0.55);\n  position: absolute;\n  top: 0;\n  left: 0;\n  right: 0;\n  bottom: 0;\n  z-index: 2;\n  border: 0; }\n"]
            },] },
];
/** @nocollapse */
SwsLoadingComponent.ctorParameters = function () { return []; };
SwsLoadingComponent.propDecorators = {
    "dataObservable": [{ type: core.Input },],
    "textNotFound": [{ type: core.Input },],
    "textError": [{ type: core.Input },],
    "download": [{ type: core.Input },],
    "isTable": [{ type: core.Input },],
    "dataOut": [{ type: core.Output },],
};
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
var SwsLoadingModule = /** @class */ (function () {
    function SwsLoadingModule() {
    }
    return SwsLoadingModule;
}());
SwsLoadingModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule
                ],
                declarations: [SwsLoadingComponent],
                exports: [SwsLoadingComponent]
            },] },
];
/** @nocollapse */
SwsLoadingModule.ctorParameters = function () { return []; };

exports.SwsLoadingComponent = SwsLoadingComponent;
exports.SwsLoadingModule = SwsLoadingModule;
exports.LoadingState = LoadingState;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=sws-loading-udfl.umd.js.map
